TOOL_NAME = "AB FX"

--Renoise Keybinds and menus
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME,
  invoke = function()main_toggle()end    
}
--[[
renoise.tool():add_keybinding {
  name = "Global:Tools:A/B Selected Track Device With Next",
  invoke = function()a_b_selected_device_with_next()end    
}
--]]

renoise.tool():add_keybinding {
  name = "Global:Tools:AB Tracks In Selected Group",
  invoke = function()cycle_solo_within_selected_group()end    
}

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:"..TOOL_NAME,
  invoke = function()main_start()end  
}
-----------------------
--Device menu entry
-----------------------
renoise.tool():add_menu_entry {
  name = "DSP Device:"..TOOL_NAME,
  invoke = function()main_start()end
  
}

--[[
------------------------------------------
--Set up Preferences file
------------------------------------------
--create xml
local options = renoise.Document.create {
  value_a = false,
  value_b = 10,
}
 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
------------------------------------------
--variable syntax 
--options.value_a.value
--]]

--------------------------------------------------------------------------------
--some basic colors for gui elements
--------------------------------------------------------------------------------
--e.g. For changing vb.views["sample present colour 2"].color when states change
COLOR_GREY = {0x30,0x42,0x42}
COLOR_ORANGE ={0xFF,0x66,0x00}
COLOR_YELLOW = {0xE0,0xE0,0x00}
COLOR_BLUE = {0x50,0x40,0xE0}  
COLOR_RED = {0xEE,0x10,0x10}
COLOR_GREEN = {0x20,0x99,0x20}
COLOR_RED_MILD = {0x90,0x10,0x10}

--Constants holding first index of color-code: Used to identify color in vb.views table i.e.
--if vb.views["button"].color[1] == COLOR_ORANGE_FLAG then --etc
COLOR_GREY_FLAG = COLOR_GREY[1]
COLOR_ORANGE_FLAG = COLOR_ORANGE[1]
COLOR_YELLOW_FLAG = COLOR_YELLOW[1]
COLOR_BLUE_FLAG = COLOR_BLUE[1]  
COLOR_RED_FLAG = COLOR_RED[1]
COLOR_GREEN_FLAG = COLOR_GREEN[1]
COLOR_RED_MILD_FLAG = COLOR_RED_MILD[1]


LUA_COUNTS_FROM_1 = 1

--global variables for gui
local my_dialog = nil 
local vb = nil


------------------------------------------------
function cycle_solo_within_selected_group()
 -----------------------------------------------
  local song = renoise.song()
  local selected_track = song.selected_track
  
  local parent_group = song.selected_track.group_parent --ob or nil
  
  --count a selected group as the parent track
  if song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP then
    parent_group = song.selected_track
  end  
  --return if we are not on a group member track
  if parent_group == nil then
    status("Track Not In A Group-Track")
    return
  end
  
 -- print(parent_group.name)
  
  --loop to get first and last track indexes in group
  local start_track = nil
  local end_track = nil
  for i = 1,song.sequencer_track_count do
    if (rawequal(song:track(i).group_parent,parent_group) == true) and (start_track == nil) then
      start_track = i
    end
    if (rawequal(song:track(i).group_parent, parent_group) == true) then
      end_track = i
    end
  end
  
  --loop group members
  local unmuted_track = nil
  local active_count = 0
  for i = start_track,end_track do
    if (song:track(i).mute_state == renoise.Track.MUTE_STATE_ACTIVE) then
      --active count will be more than 1 if we have multiple active tracks
      active_count = active_count + 1
      --get first unmuted track index
      if (unmuted_track == nil) then
        unmuted_track = i
      end
    end
    
    print(i.." "..rawequal(song:track(i).group_parent,parent_group))
    --mute tracks as we go
   -- if (rawequal(song:track(i).group_parent,parent_group) == true) then
     -- print(song:track(i).group_parent.name)
      song:track(i).mute_state = renoise.Track.MUTE_STATE_OFF
   -- end
  end
   
  if unmuted_track == nil then --default to end track so that start_track will be the next unmuted track
    unmuted_track = end_track
  end
  --if more than one track is active, set unmuted_track to end_track so that 
  --we will loop back round to first track
  if active_count > 1 then
    unmuted_track = end_track
  end
  

  -----------
  
  ------------
  
  local next_track = unmuted_track + 1
  
  while true do
    if (rawequal(song:track(next_track).group_parent,parent_group) == false) and
        (next_track < end_track) then
      next_track = next_track + 1
    else
      break
    end
  end
   
  --set new active track
  if (next_track) <= end_track then
     song:track(next_track).mute_state = renoise.Track.MUTE_STATE_ACTIVE
   --  song.selected_track_index = unmuted_track + 1
  else
    song:track(start_track).mute_state = renoise.Track.MUTE_STATE_ACTIVE 
   -- song.selected_track_index = start_track
  end
end
------------------------------------------------------------------------
------------------------------------------------------------------------


--toggle the tool open and closed (keyboard shortcut start-up)
-------------------------------------------------------------
function main_toggle()
----------------------
 --close dialog if it is open
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  else --run main
    main()
  end
end

--always open/ restart tool (menu entry start-up)
-------------------------------------------------
function main_start()
---------------------
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  end
  --run main
  main()
end
----------------------------------------------------------

function a_b_selected_device_with_next()
  local song = renoise.song()
  local selected_track = song.selected_track
  local track_idx = song.selected_track_index
  
  local dev_a = song.selected_track_device
  local dev_b = song.selected_track:device(song.selected_track_device_index + 1)
  
  --toggle selected track A with track B
  if dev_a.is_active == true then
    dev_a.is_active = false
    dev_b.is_active = true
    --update button colours
    vb.views["device a button"].color = COLOR_GREY
    vb.views["device b button"].color = COLOR_ORANGE
    
  else
    dev_a.is_active = true
    dev_b.is_active = false
    --update button colours
    vb.views["device a button"].color = COLOR_ORANGE
    vb.views["device b button"].color = COLOR_GREY
  end 
end
-------------------------------------



--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
function status(message)
  renoise.app():show_status(TOOL_NAME.." Tool: ("..message..")")
end


--function to populate the track list popups
------------------------------------
function get_sequencer_track_names()
------------------------------------
  local song = renoise.song()
  local name_table = {}
  --loop tracks
  for i = 1,song.sequencer_track_count do
    name_table[i] = song:track(i).name
  end
  
  return name_table
end

--get names of devices present in current track for the popups  
------------------------------------------
------------------------------------------
local function get_selected_track_device_display_names()
------------------------------------------

  local song  = renoise.song()
  local name_table = {}
  --loop devices
  for i = 2,#song.selected_track.devices do
    
    --NOTE: when device is not renamed by the user you get a default long name in the .display_name format:
    --[VST: Manufacturer: Plug Name] e.g. [VST: Renoise: Redux]
    --get the full name of the device
    local name = song.selected_track.devices[i].display_name

    --find first ":" pos
    local cln = string.find(name,":")
    --if colon is present then display name is in the long format so we strip out parts
    --"VST: " and "Manufacturer:" 
    if cln ~= nil then
      --delete up to cln pos (+1 to include colon)
      name = string.sub(name,cln + 1) 
      --repeat as two ":" are in the long name
      cln = string.find(name,":")
      --update name
      name = string.sub(name,cln + 1) --delete colon and spaces so +
    end
    
    --prepend device index with bracket e.g. "3)"
    name = tostring((i-1)).."] "..name
    --add to name table
    name_table[i-1] = name
  end
  
  --return table of shortened device names present in the selected track
  return name_table
end
------------------------------------------




------------------------------------
------------------------------------
function main()
------------------------------------
------------------------------------

  
  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    return
  end
  
  --remove timer (in case tool crashes and timer not released)
  if renoise.tool():has_timer(timer) then
    renoise.tool():remove_timer(timer)
  end
  
  --renoise song object
  local song = renoise.song()

  --set globals
  -------------
  --assign global vb to viewbuilder
  vb = renoise.ViewBuilder()
  
  

  --get first-start indexes (selected item) for popups
  ---------------------------------------------------- 
 
  --TODO similar behavioour when track changed and tool is open
 
  --get device names for the current track
  local cur_track_dev_names = get_selected_track_device_display_names()
  --get the selected device index for current track
  local selected_device_idx =  song.selected_track_device_index
  --update global to current track aswell (used in timer)
  g_selected_track_idx = song.selected_track_index
  
  --default to popup index 1 (will show as "none" if no devices are present in the track or first item if only one exists)
  local device_popup_one_index = 1
  local device_popup_two_index = 1
 
 
 --TODO tidy and cover all cases!!
 
  --if there is a device after the selected device then set first-popup to selected device and second-popup 
  --to the next device
  if (#song.selected_track.devices > selected_device_idx) and (selected_device_idx > 1) then
    device_popup_one_index = selected_device_idx - 1 --adjust for offset (mixer device not included in popup)
    device_popup_two_index = selected_device_idx
  --elseif only 2 user devices then select them as first = 1 and second = 2 (no matter which is selected in renoise)
  elseif #song.selected_track.devices > 2 then 
    device_popup_two_index = 2
  end
  -----------------------------------------------

  local BUTTON_WIDTH = 141
  local BUTTON_HEIGHT = 35
  ----------------------------------------------
  --GUI
  ----------------------------------------------     

  --variables that will be added to
  --dialog_content:add_child(send_row)
  local main_column =
   vb:column{
    --[[ vb:row{
      vb:text{
       text = "  Track A/B",
       },
      },
      
     vb:row{
      margin = 4,
       vb:popup{
       width = 120,
        id = "track a popup",
        items = get_sequencer_track_names(),
        value = renoise.song().selected_track_index,
         },
       vb:popup{
        width = 120,
        id = "track b popup",
        items = get_sequencer_track_names(),
        value = (renoise.song().selected_track_index + 1),
       },
      },
    
     vb:row{
      margin = 4,
      vb:button{ 
       width = 120,
       height = 30,
       id = "track a button",
       text = "Trk A",
       notifier = function()
                    local song = renoise.song()
                    local track_idx = song.selected_track_index
                    
                    local trk_a = song:track(vb.views["track a popup"].value)
                    local trk_b = song:track(vb.views["track b popup"].value)
                    
                    --toggle selected track A with track B
                    if trk_a.mute_state ~= renoise.Track.MUTE_STATE_OFF then
                      trk_a.mute_state = renoise.Track.MUTE_STATE_OFF
                      trk_b.mute_state = renoise.Track.MUTE_STATE_ACTIVE
                      --update button colours
                      vb.views["track a button"].color = COLOR_GREY
                      vb.views["track b button"].color = COLOR_ORANGE
                      
                    else
                      trk_a.mute_state = renoise.Track.MUTE_STATE_ACTIVE
                      trk_b.mute_state = renoise.Track.MUTE_STATE_OFF
                      --update button colours
                      vb.views["track a button"].color = COLOR_ORANGE
                      vb.views["track b button"].color = COLOR_GREY
                    end
                  
                  
                  end
      },--button
     
      vb:button{ 
       width = 120,
       height = 30,
       id = "track b button",
       text = "Trk B",
       notifier = function()
                    local song = renoise.song()
                    local track_idx = song.selected_track_index
                    
                    local trk_a = song:track(vb.views["track a popup"].value)
                    local trk_b = song:track(vb.views["track b popup"].value)
                    
                    --toggle selected track A with track B
                    if trk_a.mute_state ~= renoise.Track.MUTE_STATE_OFF then
                      trk_a.mute_state = renoise.Track.MUTE_STATE_OFF
                      trk_b.mute_state = renoise.Track.MUTE_STATE_ACTIVE
                      --update button colours
                      vb.views["track a button"].color = COLOR_GREY
                      vb.views["track b button"].color = COLOR_ORANGE
                      
                    else
                      trk_a.mute_state = renoise.Track.MUTE_STATE_ACTIVE
                      trk_b.mute_state = renoise.Track.MUTE_STATE_OFF
                      --update button colours
                      vb.views["track a button"].color = COLOR_ORANGE
                      vb.views["track b button"].color = COLOR_GREY
                    end                 
                  end
      },--button
     },--Trk Buttons row
     --]]

    vb:row{
      margin = 4,
      vb:text{
        text = "                                                                     "--lazy spacer
      },  
      vb:button{
       color = COLOR_GREY,
       text = "Toggle All FX",
       notifier = function()
                    local song = renoise.song()
                    local num_devices = #song.selected_track.devices
                    
                    if num_devices == 1 then 
                      return
                    end
                    --use state of first device for all toggles
                    local state = not song.selected_track:device(2).is_active
                    
                    for i = 2,#song.selected_track.devices do
                      song.selected_track:device(i).is_active = state
                    end
                  
                  end
      }
   },
     
    vb:row{
      margin = 4,
      vb:button{
       color = COLOR_GREY,
       text = "Bypass",
       notifier = function()
                      local song = renoise.song()
                      --check index is for a legitimate device (can sometimes point to a device that was deleted)
                      if vb.views["device a popup"].value >= #song.selected_track.devices then --(greater than or-equal-to, as mixer not counted in popups)
                        return
                      end
                      --check index is for a legitimate device (can sometimes point to a device that was deleted)
                      if vb.views["device b popup"].value >= #song.selected_track.devices then
                        return
                      end
                      --get device a object
                      local dev_a_rns_track_idx = vb.views["device a popup"].value + 1
                      local dev_a = song.selected_track:device(dev_a_rns_track_idx)
                      --get device b object
                      local dev_b_rns_track_idx = vb.views["device b popup"].value + 1
                      local dev_b = song.selected_track:device(dev_b_rns_track_idx)
                      
                      if (dev_a.is_active == false) and (dev_b.is_active == false) then
                        --activate both if both are switched off
                        dev_a.is_active = true
                        dev_b.is_active = true
                      else
                        --disable both if either or both are already on
                        dev_a.is_active = false
                        dev_b.is_active = false
                      end
                      
                  
                  
                  end
      
       },
       
     --  vb:text{
      --  text = "                                                             "
     --  },
      
      vb:button{
       text = "Sel + 1",
       id = "sel + 1",
       color = COLOR_GREY,
       notifier = function()
                      local COUNT = 8
                      local song = renoise.song()
                      local cur_dev_idx = song.selected_device_index
                      
                      --if mixer device or no device is selected then return with a failed status
                      if (song.selected_device_index <= 1)then
                        status("FAILED! Select a Valid Device")
                       -- g_sel_plus_one_color_counter = COUNT
                       -- vb.views["sel + 1"].color = COLOR_RED --turn button red (temporarily as timer will turn it grey again)
                        return
                      end 
                      
                      local cur_dev = song.selected_track_device
                      local cur_dev_popup_target_idx = cur_dev_idx -1
                      
                      --is there more than 1 device in this track?
                      if (#vb.views["device a popup"].items > 1) and 
                        (cur_dev_popup_target_idx < #vb.views["device a popup"].items) then
                        
                        vb.views["device a popup"].value = cur_dev_popup_target_idx 
                        vb.views["device b popup"].value = cur_dev_popup_target_idx + 1
                        --update status
                        status("DONE! Selected Device and Selected Device + 1, Set")
                          g_sel_plus_one_color_counter = COUNT 
                         vb.views["sel + 1"].color = COLOR_GREEN --turn button green (temporarily as timer will turn it grey again)
                      -- vb.views["sel + 1"].active = false 
                      else
                        --update status
                        status("FAILED! Select a Valid Device")
                      --  g_sel_plus_one_color_counter = COUNT 
                      -- vb.views["sel + 1"].color = COLOR_RED --turn button red (temporarily as timer will turn it grey again)
                      end

                  end
      
       },
      },
     vb:row{
      vb:text{
       text = "                                ",--text and spacer
       },
       
       vb:button{
         color = COLOR_GREY,
         id = "S button one",
         text = "S",
         notifier = function()
                      local song = renoise.song()
                      --Select device B in renoise
                      local dev_a_rns_track_idx = vb.views["device a popup"].value + 1
                      song.selected_track_device_index = dev_a_rns_track_idx
                    end
       },
      vb:button{
      color = COLOR_GREY,
       id = "dev a external ed button",
       text = "Ed.",
       notifier = function()
                    --song object
                    local song = renoise.song()
                    
                    local selected_track = song.selected_track
                    local track_idx = song.selected_track_index
                    --the get the indexes of the selected devices in the popusp (+1 to account for missing mixer device in popup)
                    local dev_a_rns_track_idx = vb.views["device a popup"].value + 1
                    local dev_a = selected_track:device(dev_a_rns_track_idx)
                    
                    --toggle external editor
                    if (dev_a.external_editor_available == true) then
                      if (dev_a.external_editor_visible == false) then
                        dev_a.external_editor_visible = true
                      else
                        dev_a.external_editor_visible = false
                      end
                    
                    end
                  end
       },
       vb:text{ 
        text = "                             ",--spacer
       
       },
       vb:button{
         color = COLOR_GREY,
         id = "S button two",
         text = "S",
         notifier = function()
                      local song = renoise.song()
                      --Select device B in renoise
                      local dev_b_rns_track_idx = vb.views["device b popup"].value + 1
                      song.selected_track_device_index = dev_b_rns_track_idx
                    
                    end
       },
       
      vb:button{
       color = COLOR_GREY,
       id = "dev b external ed button",
       text = "Ed.",
       notifier = function()
                    local song = renoise.song()
                    local selected_track = song.selected_track
                    local track_idx = song.selected_track_index
                    --the get the indexes of the selected devices in the popusp (+1 to account for missing mixer device in popup)
                    local dev_b_rns_track_idx = vb.views["device b popup"].value + 1
                    local dev_b = selected_track:device(dev_b_rns_track_idx)
                    
                    --toggle external editor
                    if (dev_b.external_editor_available == true) then
                      if (dev_b.external_editor_visible == false) then
                        dev_b.external_editor_visible = true
                      else
                        dev_b.external_editor_visible = false
                      end
                    
                    end
     
                  end
       },
      },
      
     vb:row{
      margin = 4,
       vb:popup{
        id = "device a popup",
        width = BUTTON_WIDTH,
        items = cur_track_dev_names,
        value = device_popup_one_index,
        notifier = function()
                     --reset sel+1 button to grey
                    -- vb.views["sel + 1"].color = COLOR_GREY
                   end
         },
       vb:popup{
        id = "device b popup",
        width = BUTTON_WIDTH,
        items = cur_track_dev_names,
        value = device_popup_two_index,
        notifier = function()
                     --reset sel+1 button to grey
                    -- vb.views["sel + 1"].color = COLOR_GREY
                   end
       },
      },
      
    vb:row{
      margin = 4,
      vb:button{ 
       color = COLOR_GREY,
       id = "device a button",
       width = BUTTON_WIDTH,
       height = BUTTON_HEIGHT,
       text = "Dev A",
       notifier = function()
                    local song = renoise.song()
                    local selected_track = song.selected_track
                    local track_idx = song.selected_track_index
                    
                    --Check popup selection is valid (in case not caught by timer (rare case user presses this fast))
                    -------------------------------- 
                    --if the device at the end of the chain has been deleted and was selected in the popup
                    --the popup can show "None" with an invalid index still present
                    if vb.views["device a popup"].value > #vb.views["device a popup"].items then
                       vb.views["device a popup"].value = #vb.views["device ab popup"].items
                      status("popup a needed resetting, press button again")
                      return
                    end
                    if vb.views["device b popup"].value > #vb.views["device b popup"].items then
                       vb.views["device b popup"].value = #vb.views["device b popup"].items
                       status("popup a needed resetting, press button again")
                      return
                    end
                    
                    --the get the indexes of the selected devices in the popusp (+1 to account for missing mixer device in popup)
                    local dev_a_rns_track_idx = vb.views["device a popup"].value + 1
                    local dev_b_rns_track_idx = vb.views["device b popup"].value + 1
                    
                    local dev_a = selected_track:device(dev_a_rns_track_idx)
                    local dev_b = selected_track:device(dev_b_rns_track_idx)
                    
                    --both already active, or both inactive then toggle A on and B off.
                    if (dev_a.is_active == dev_b.is_active) then
                      dev_a.is_active = true
                      dev_b.is_active = false
                      --update button colours
                      vb.views["device a button"].color = COLOR_ORANGE
                      vb.views["device b button"].color = COLOR_GREY
                    --A active alone then toggle A off and b on
                    elseif (dev_a.is_active == true) and (dev_b.is_active == false) then
                      dev_a.is_active = false
                      dev_b.is_active = true
                      --update button colours
                      vb.views["device a button"].color = COLOR_GREY
                      vb.views["device b button"].color = COLOR_ORANGE
                     --B active alone then toggle A on and B off
                    elseif (dev_a.is_active == false) and (dev_b.is_active == true) then 
                      dev_a.is_active = true
                      dev_b.is_active = false
                      --update button colours
                      vb.views["device a button"].color = COLOR_ORANGE
                      vb.views["device b button"].color = COLOR_GREY
                    end
                    
                    
                  end
      },--button
     
      vb:button{
       color = COLOR_GREY,
       id = "device b button",
       width = BUTTON_WIDTH,
       height = BUTTON_HEIGHT,
       text = "Dev B",
       notifier = function()
                    local song = renoise.song()
                    local selected_track = song.selected_track
                    local track_idx = song.selected_track_index
                    
                    --Check popup selection is valid (in case not caught by timer (rare case user presses this fast))
                    -------------------------------- 
                    --if the device at the end of the chain has been deleted and was selected in the popup
                    --the popup can show "None" with an invalid index still present
                    if vb.views["device a popup"].value > #vb.views["device a popup"].items then
                       vb.views["device a popup"].value = #vb.views["device ab popup"].items
                      status("popup a needed resetting, press button again")
                      return
                    end
                    if vb.views["device b popup"].value > #vb.views["device b popup"].items then
                       vb.views["device b popup"].value = #vb.views["device b popup"].items
                       status("popup a needed resetting, press button again")
                      return
                    end
                    
                    --the get the indexes of the selected devices in the popusp (+1 to account for missing mixer device in popup)
                    local dev_a_rns_track_idx = vb.views["device a popup"].value + 1
                    local dev_b_rns_track_idx = vb.views["device b popup"].value + 1
                    
                    local dev_a = selected_track:device(dev_a_rns_track_idx)
                    local dev_b = selected_track:device(dev_b_rns_track_idx)
                    
                    --both already active, or both inactive then toggle A on and B off.
                    if (dev_a.is_active == dev_b.is_active) then
                      dev_a.is_active = false
                      dev_b.is_active = true
                      --update button colours
                      vb.views["device a button"].color = COLOR_GREY
                      vb.views["device b button"].color = COLOR_ORANGE
                    --A active alone then toggle A off and b on
                    elseif (dev_a.is_active == true) and (dev_b.is_active == false) then
                      dev_a.is_active = false
                      dev_b.is_active = true
                      --update button colours
                      vb.views["device a button"].color = COLOR_GREY
                      vb.views["device b button"].color = COLOR_ORANGE
                     --B active alone then toggle A on and B off
                    elseif (dev_a.is_active == false) and (dev_b.is_active == true) then 
                      dev_a.is_active = true
                      dev_b.is_active = false
                      --update button colours
                      vb.views["device a button"].color = COLOR_ORANGE
                      vb.views["device b button"].color = COLOR_GREY
                    end
                  end
      },--button
     },--Trk Buttons row
  

     
    }--main column
  -------------------------------


  --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb:column{}
  dialog_content:add_child(main_column)


  
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      TOOL_NAME, dialog_content,my_keyhandler_func)


  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,50)
  end

  
  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog
     my_dialog = nil 
     --reset selected_track to nil
     g_selected_track_idx = nil
  end
  -- notifier to close dialog on load new song
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  -------------------------------------------------------------------------------
  
  --first run of timer
   timer()
end
--------------
--end main()
--------------

--GLOBALS USED IN TIMER
-----------------------
--to store selected track
g_selected_track_idx = nil
--counter for when sel + 1 button has been pressed
g_sel_plus_one_color_counter = 0 

----------------
--timer function
----------------
function timer()
----------------
    
  --song object
  local song = renoise.song()
  --get table with the names of all devices on track
  local popup_display_names =  get_selected_track_device_display_names() 
  --popuplate the popups with the devices present in selected track
  vb.views["device a popup"].items = popup_display_names
  vb.views["device b popup"].items = popup_display_names
 
  --get number of devices from length of table
  local num_devs = #popup_display_names
  local song_dev_idx = song.selected_device_index
  

  --Check popup selection is valid
  --------------------------------
  --if the device at the end of the chain has been deleted and the popup value was set to that that last device,
  --then the popup.value will remain at an index that no longer exists in the popup updated (above) list.  It does not update automatically in the API.
  --here we take care of this and set the value to the last legitimate popup value in the new items list.
  if vb.views["device a popup"].value > #vb.views["device a popup"].items then
    vb.views["device a popup"].value = #vb.views["device b popup"].items
  end
  if vb.views["device b popup"].value > #vb.views["device b popup"].items then
    vb.views["device b popup"].value = #vb.views["device b popup"].items
  end
  

  --TRACK CHANGED?
  ----------------
  if song.selected_track_index ~= g_selected_track_idx then
    --update global g_selected_track_idx with current track index
    g_selected_track_idx = song.selected_track_index
    --update local song_dev_idx
    song_dev_idx = song.selected_device_index
    --default popup values to 1  
    vb.views["device a popup"].value = 1
    vb.views["device b popup"].value = 1
    --if more than one user device on track then set popup values to 1 and 2
    if num_devs > 1 then
      vb.views["device b popup"].value = 2
    end
    --set selected device to popup 1 and [sel + 1] to popup 2 if possible
    if (song_dev_idx > 1) and (song_dev_idx < num_devs + 1) and (num_devs > 1) then
      vb.views["device a popup"].value = song_dev_idx - 1
      vb.views["device b popup"].value = song_dev_idx 
    end
  end
  
  --disable / enable sel + 1 button
  ----------------------------------
  if (song_dev_idx <= 1) or (song_dev_idx >= num_devs + 1) then
    vb.views["sel + 1"].active = false
  else
    vb.views["sel + 1"].active = true
  end
  
  
  --flash [sel + 1] button green, if been pressed
  -- (counter gets set in button notifier)
  -------------------------------------------------
  if g_sel_plus_one_color_counter ~= 0 then
    --turn button grey when counter reaches 1 (0 becomes reset so will not pass if test above)
    if g_sel_plus_one_color_counter == 1 then
      vb.views["sel + 1"].color = COLOR_GREY
    end
    --decrement counter
    g_sel_plus_one_color_counter = g_sel_plus_one_color_counter - 1 
  end
  
  --disable the buttons if (device a matches device b) or (no devices present) 
  ---------------------------------------------------------------------------- 
  if (vb.views["device a popup"].value == vb.views["device b popup"].value) or (num_devs == 0) then
    vb.views["device a button"].active = false
    vb.views["device b button"].active = false
  else
    vb.views["device a button"].active = true
    vb.views["device b button"].active = true
  end

  
  --UPDATE BUTTON COLORS
  -----------------------
  --0 devices (in track)
  --------------------
  if num_devs == 0 then --if no devices then grey the buttons
    vb.views["device a button"].color = COLOR_GREY
    vb.views["device b button"].color = COLOR_GREY
  
  --1 device
  -----------
  elseif num_devs == 1 then --if one device then 
   
    if song.selected_track:device(2).is_active == true then
      vb.views["device a button"].color = COLOR_ORANGE
    else
      vb.views["device a button"].color = COLOR_GREY
    end

  --2 or more devices
  -------------------
  else 
    --variables to hold device objects selected in popup 1 and 2
    local dev_a = nil
    local dev_b = nil
    --check popup index points to a legitimate device (i.e. not been deleted in renoise)
    if num_devs >= (vb.views["device a popup"].value) then
      dev_a = song.selected_track:device(vb.views["device a popup"].value + 1)--(+1 due to mixer)
    end
    --check popup index points to a legitimate device (i.e. not been deleted in renoise)
    if num_devs >= (vb.views["device b popup"].value) then
      dev_b = song.selected_track:device(vb.views["device b popup"].value + 1)--(+1 due to mixer)
    end
    --DEVICE/POPUP A: button color
    ----------------------------------------------
    --update button color to match chosen device state in renoise
    if (dev_a ~= nil) and (dev_a.is_active == true) then
      vb.views["device a button"].color = COLOR_ORANGE
    else
      vb.views["device a button"].color = COLOR_GREY
    end
    --DEVICE/POPUP B: botton color
    ----------------------------------------------
    if (dev_b ~= nil) and (dev_b.is_active == true) then
      vb.views["device b button"].color = COLOR_ORANGE
    else
      vb.views["device b button"].color = COLOR_GREY
    end 
  end --end BUTTON COLORS
  -----------------------
  
  --remove timer when GUI is closed
  if(my_dialog == nil) or (my_dialog.visible == false) then
    if renoise.tool():has_timer(timer) then
      renoise.tool():remove_timer(timer)
    end
  end
end





